﻿package game.main
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	
	import game.personalities.*;
	import game.core.*;
	import game.utils.*;

	
	
	public class BlackJack extends MovieClip
	{
		public var numberOfDecks:Number = 2;

		
		public var myDeck:BlackJackDeck;

		public var player0:Player;
		public var dealer:Dealer;
		
		public var playerDisplay_mc:CardDisplay;
		public var dealerDisplay_mc:CardDisplay;
		
		public var myAlertDialog:AlertDialog;

		// Placed on stage
		public var hit_ib:SimpleButton;
		public var stand_ib:SimpleButton;
		public var newGame_ib:SimpleButton;
		
		public var hit_ib_txt:TextField;
		public var stand_ib_txt:TextField;
		public var newGame_ib_txt:TextField;
		
		public var player_ta:TextField;
		public var dealer_ta:TextField;

		public var playerVal_ti:TextField;
		public var dealerVal_ti:TextField;
		
		public var playerBankRoll_ti:TextField;
		public var playerBet_ti:TextField;

		public function BlackJack()
		{
			init();
		}
		
		function init():void
		{
			myDeck = new BlackJackDeck(numberOfDecks);
	
			player0 = new Player();
			dealer = new Dealer();
			
			hit_ib.visible = false;
			stand_ib.visible = false;
			hit_ib_txt.visible = false;
			stand_ib_txt.visible = false;
			hit_ib_txt.mouseEnabled = false;
			stand_ib_txt.mouseEnabled = false;
			newGame_ib_txt.mouseEnabled = false;
			
			playerBankRoll_ti.text = player0.bankRoll;
			
			playerDisplay_mc = new CardDisplay();
			playerDisplay_mc.x = 10;
			playerDisplay_mc.y = 85;
			playerDisplay_mc.name = "playerDisplay_mc";
			
			dealerDisplay_mc = new CardDisplay();
			dealerDisplay_mc.x = 285;
			dealerDisplay_mc.y = 85;
			dealerDisplay_mc.name = "dealerDisplay_mc";
			
			addChild(playerDisplay_mc);
			addChild(dealerDisplay_mc);
			
			hit_ib.addEventListener("click", hitHandler);
			stand_ib.addEventListener("click", standHandler);
			newGame_ib.addEventListener("click", newGameHandler);
			
			var myAlertDialog:AlertDialog = new AlertDialog();
		}

		function deal():void
		{
			player0.addCard(myDeck.pop());
			dealer.addCard(myDeck.pop());
			player0.addCard(myDeck.pop());
			dealer.addCard(myDeck.pop());
			
			player_ta.text = player0.__hand;
			playerVal_ti.text = player0.getHandValue();
			
			//dealer_ta.text = dealer.__hand;
			//dealerVal_ti.text = dealer.getHandValue();
			dealer_ta.text = "";
			dealerVal_ti.text = "";
			
			displayHand(player0, playerDisplay_mc, false);
			displayHand(dealer, dealerDisplay_mc, true);
		}


		function hitHandler(evt:MouseEvent):void
		{
			player0.addCard(myDeck.pop());
			player_ta.text = player0.__hand;
			playerVal_ti.text = player0.getHandValue();
			displayHand(player0, playerDisplay_mc, false);
		
			if(player0.getHandValue() > 21)
			{
				//Alert.show("You lose!");
				trace("You lose!");
				
				showAlert(-1);
				
				hit_ib.visible = false;
				stand_ib.visible = false;
				hit_ib_txt.visible = false;
				stand_ib_txt.visible = false;
			}
		}


		function standHandler(evt:MouseEvent):void
		{
			hit_ib.visible = false;
			stand_ib.visible = false;
			hit_ib_txt.visible = false;
			stand_ib_txt.visible = false;
			
			//_root.dealerDisplay_mc.removeMovieClip("firstCard_mc");
			//_root.dealerDisplay_mc.attachMovie("FaceofCard", "card_mc0", 0, {_x:0, _y:5});
			var card_mc0:FaceofCard = new FaceofCard();
			card_mc0.x = 0;
			card_mc0.y = 5;
			card_mc0.name = "card_mc0";
			dealerDisplay_mc.addChild(card_mc0);
			
			//displayCard(_root.dealerDisplay_mc.card_mc0, _root.dealer.hand[0]);
			
			//trace("card_mc0 " + dealerDisplay_mc.card_mc0);
			//displayCard(dealerDisplay_mc.card_mc0, dealer.hand[0]);
			displayCard(card_mc0, dealer.hand[0]);
			
			dealer_ta.text = dealer.__hand;
			dealerVal_ti.text = dealer.getHandValue();
			
			
			while ( dealer.decide() == 1 )
			{
				dealer.addCard(myDeck.pop());
				dealer_ta.text = dealer.__hand;
				dealerVal_ti.text = dealer.getHandValue();
				displayHand(dealer, dealerDisplay_mc, false);
					
				if(dealer.getHandValue() > 21)
				{
					//Alert.show("You win!");
					trace("You win!");
					showAlert(1);
					return;
				}
			}
			
			if (dealer.getHandValue() > player0.getHandValue())
			{
				//Alert.show("You lose!");
				trace("You lose!");
				showAlert(-1);
			}
			else if (dealer.getHandValue() == player0.getHandValue())
			{
				//Alert.show("Push");
				trace("Push");
				showAlert(0);
			}
			else
			{
				//Alert.show("You win!");
				trace("You win!");
				showAlert(1);
			}
			
		}

		function newGameHandler(evt:MouseEvent):void
		{
			//_root.removeMovieClip("playerDisplay_mc");
			//_root.removeMovieClip("dealerDisplay_mc");
			playerDisplay_mc = null;
			dealerDisplay_mc = null;
			
			if(getChildByName("myAlertDialog"))
			{
				removeChild(myAlertDialog);
				myAlertDialog = null;
			}
			
			//_root.attachMovie("CardDisplay", "playerDisplay_mc", 1, {_x:10, _y:85});
			//_root.attachMovie("CardDisplay", "dealerDisplay_mc", 2, {_x:285, _y:85});
			
			//var playerDisplay_mc:CardDisplay = new CardDisplay();
			playerDisplay_mc = new CardDisplay();
			playerDisplay_mc.x = 10;
			playerDisplay_mc.y = 85;
			playerDisplay_mc.name = "playerDisplay_mc";
			
			//var dealerDisplay_mc:CardDisplay = new CardDisplay();
			dealerDisplay_mc = new CardDisplay();
			dealerDisplay_mc.x = 285;
			dealerDisplay_mc.y = 85;
			dealerDisplay_mc.name = "dealerDisplay_mc";
			
			addChild(playerDisplay_mc);
			addChild(dealerDisplay_mc);
		
			
			player0.reset();
			dealer.reset();
			player0.doBetting(uint(playerBet_ti.text));
			
			trace("**************** new game ************************");
			trace("deck length is " + myDeck.length);
			if(myDeck.length < 10)
			{
				trace("shuffling");
				myDeck = new BlackJackDeck(numberOfDecks);
			}
			
			deal();
			
			playerBet_ti.type = "dynamic";
			
			hit_ib.visible = true;
			stand_ib.visible = true;
			hit_ib_txt.visible = true;
			stand_ib_txt.visible = true;
			newGame_ib.visible = false;
			newGame_ib_txt.visible = false;
		}
		
		function displayHand(player, mc, isFirstTime)
		{
			trace("in displayHand " + mc.name);
			var i = 0;
			if(isFirstTime)
			{
				i=1;
				//mc.attachMovie("BackofCard", "firstCard_mc", 0, {_x:0, _y:5});
				var firstCard_mc:BackofCard = new BackofCard();
				firstCard_mc.x = 0;
				firstCard_mc.y = 5;		
				firstCard_mc.name = "firstCard_mc";
				mc.addChild(firstCard_mc);
			}
			
			for (i; i<player.hand.length; i++)
			{
				//mc.attachMovie("FaceofCard", "card_mc"+i, i, {_x:45*i, _y:5});
				//displayCard(eval("mc.card_mc"+i), player.hand[i]);
				
				var curCard_mc:FaceofCard = new FaceofCard();
				curCard_mc.x = 45 * i;
				curCard_mc.y = 5;
				curCard_mc.name = "card_mc" + i;
				mc.addChild(curCard_mc);
				
				displayCard(curCard_mc, player.hand[i]);
			}
		}
		
		function displayCard(fc, card)
		{
			trace("in displayCard " + fc.name);
			trace("card value is " + card.toString());
			switch(card.suit)
			{
				case "C":
				{
					//fc.topSuit_mc.attachMovie("Club", "topC", 1);
					//fc.bottomSuit_mc.attachMovie("Club", "bottomC", 1, {_rotation:180});
					trace("in club");
					var topC:MovieClip = new Club();
					fc.topSuit_mc.addChild(topC);
		
					var bottomC:MovieClip = new Club();
					bottomC.rotation = 180;
					fc.bottomSuit_mc.addChild(bottomC);
		
					break;
				}
				case "D":
				{
					//fc.topSuit_mc.attachMovie("Diamond", "topC", 1);
					//fc.bottomSuit_mc.attachMovie("Diamond", "bottomC", 1, {_rotation:180});
					trace("in diamond");
					var topC:MovieClip = new Diamond();
					fc.topSuit_mc.addChild(topC);
		
					var bottomC:MovieClip = new Diamond();
					bottomC.rotation = 180;
					fc.bottomSuit_mc.addChild(bottomC);
		
					break;
				}
				case "H":
				{
					//fc.topSuit_mc.attachMovie("Heart", "topC", 1);
					//fc.bottomSuit_mc.attachMovie("Heart", "bottomC", 1, {_rotation:180});
					trace("in heart");
					var topC:MovieClip = new Heart();
					fc.topSuit_mc.addChild(topC);
		
					var bottomC:MovieClip = new Heart();
					bottomC.rotation = 180;
					fc.bottomSuit_mc.addChild(bottomC);
		
					break;
				}
				case "S":
				{
					//fc.topSuit_mc.attachMovie("Spade", "topC", 1);
					//fc.bottomSuit_mc.attachMovie("Spade", "bottomC", 1, {_rotation:180});
					trace("in spade");
					var topC:MovieClip = new Spade();
					fc.topSuit_mc.addChild(topC);
		
					var bottomC:MovieClip = new Spade();
					bottomC.rotation = 180;
					fc.bottomSuit_mc.addChild(bottomC);
		
					break;
				}
			}
			fc.cardVal_txt.text = card.value;
		}
		
		function showAlert(status:int):void
		{
			myAlertDialog = new AlertDialog();
			myAlertDialog.name = "myAlertDialog";
			myAlertDialog.x = 200;
			myAlertDialog.y = 180;
			
			addChild(myAlertDialog);
			switch (status)
			{
				case -1:
				{
					trace("showAlert - you lose!");
					myAlertDialog.alert_txt.text = "You Lose!";
					player0.bankRoll -= player0.bet;
					
					break;
				}
				case 1:
				{
					trace("showAlert - you win!");
					myAlertDialog.alert_txt.text = "You Win!";
					player0.bankRoll += player0.bet;
					break;
				}
				case 0:
				{
					trace("showAlert - push!");
					myAlertDialog.alert_txt.text = "Push!";
					break;
				}
				default:
				{
					trace("showAlert - Should not get here");
				}
			}
		
			playerBankRoll_ti.text = player0.bankRoll;
			newGame_ib.visible = true;
			newGame_ib_txt.visible = true;
			playerBet_ti.type = "input";
		}
	}
}