﻿package game.personalities
{
	import game.core.BlackJackCard;
	
	public class Player
	{
		//var __hands:Array;	// an array of hands
		public var __hand:Array;		// an array of cards
		var __value:Number;
		var soft:Boolean;
		var busted:Boolean;
		public var bet:uint = 5;
		//var defaultBetValue:Number = 5;
		public var bankRoll:uint = 2000;
		var isDealer:Boolean = false;
	
		public function Player()
		{
			__hand = new Array();
		}
	
		public function reset()
		{
			__hand = [];
			__value = 0;
			soft = false;
			busted = false;
		}
	
		// each type of player should implement their own strategy here
		public function decide():Number
		{
			// for now, just implement the same rules as the dealer
			var v = this.getHandValue();
			if( (v < 17) || (v == 17 && this.soft) )
			{
				return hit();
			}
			else
			{
				return stand();
			}
		}
	
		public function hit():Number
		{
			return 1;		// The BlackJack game controller expects 1 for hit
		}
	
		public function stand():Number
		{
			return 2;		// The BlackJack game controller expects 2 for stand
		}
	
		public function addCard(card:Object):Array
		{
			trace("adding card " + card);
			__hand.push(card);
	
			return __hand;
		}
	
		public function getHandValue():Number
		{
			trace("in getHandValue");
			soft = false;
			var sum = 0;
			for (var i=0; i < __hand.length; i++)
			{
				trace(" i is " + i + " hand is " + __hand[i]);
				sum += __hand[i].getBJValue();
				if (__hand[i].getBJValue() == 1)
				{
					soft = true;
				}
			}
			
			if (soft && sum+10 <= 21)
			{
				sum += 10;
			}
			
			__value = sum;
	
			return __value;
		}
	
		public function get hand():Array
		{
			return __hand;
		}
		
		/*
		public function doBetting(hiLoCount:Number):Number
		{
			bet = defaultBetValue;
			return bet;
		}
		*/
		
		public function doBetting(myBet:uint):Number
		{
			bet = myBet;
			return bet;
		}
	}
}